﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using Newtonsoft.Json.Linq;

namespace documentAttachment
{
    public class requesting_attachments_rest
    {
        public static void Main(string[] args)
        {

            //replace api_key placeholder with your own value
            string apiKey = "YOUR_API_KEY";
            string url = "https://sandbox.e-signlive.com/api";

            //JSON string to add a role with attachment required
            string jsonString = "{ \"roles\": [ { \"id\": \"client\", \"type\": \"SIGNER\", \"index\": 1, \"attachmentRequirements\": [ { \"description\": \"Please upload a scanned copy of your driver's license.\", \"required\": true, \"id\": \"lD6p5QnWk905\", \"data\": null, \"status\": \"INCOMPLETE\", \"comment\": \"\", \"name\": \"Driver's license\" } ], \"signers\": [ { \"firstName\": \"John\", \"lastName\": \"Smith\", \"email\": \"john.smith@gmail.com\" } ], \"name\": \"client\" }, { \"id\": \"contractor\", \"type\": \"SIGNER\", \"index\": 2, \"signers\": [ { \"firstName\": \"Bob\", \"lastName\": \"Murray\", \"email\": \"bob.murray@gmail.com\" } ], \"name\": \"contractor\" } ] }";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            //add a role with required attachment
            var response = myClient.PostAsync(new Uri(url) + "/packages/{pacakgeId}/roles", jsonContent).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);

            //retrieve status of each attachment
            var roles = myClient.GetAsync(new Uri(apiUrl + "/packages/{packageId}/roles")).Result;
            JObject roles_json = JObject.Parse(roles.Content.ReadAsStringAsync().Result);
            var results = roles_json["results"];

            foreach (var attachment in results)
            {
                var attach = attachment["attachmentRequirements"];
                Debug.WriteLine(attach);
            }

            //download attachment
            var result = myClient.GetAsync(new Uri(url + "/packages/{packageId}/attachment/{attachmentId}")).Result;
            ByteArrayContent content = new ByteArrayContent(result.Content.ReadAsByteArrayAsync().Result);
            File.WriteAllBytes("PATH_TO_DOWNLOAD", content.ReadAsByteArrayAsync().Result);

        }
    }
}
